{
"  ".   ,     .
,      ,     ,
   .
}
program p110n15;

{$APPTYPE CONSOLE}

uses
  SysUtils, Windows;

type
  TItem = record
    //name: string [20];
    Price: single;
    Weight: single;
    Rate: real;
    end;
  TList = array of TItem;

var
  m: integer;
  Limit,Sum: single;
  List: TList;

procedure InputItem (var I: TItem);
begin
  write (':> ');
  readln (I.Price,I.Weight);
  I.Rate:=I.Price / I.Weight;
end;

procedure InputList (var L: TList; var m: integer);
var
  i: integer;
begin
  SetConsoleCP (1251);
  SetConsoleOutputCP (1251);
  write ('   : ');
  readln (m);
  SetLength (L,m+1);
  writeln ('    ',M,' : ');
  for i:=1 to m do
    InputItem(L[i]);
end;

procedure Swap (var x,y: TItem);
var
  t: TItem;
begin
  t:=x;
  x:=y;
  y:=t;
end;

procedure QuickSort (var a: TList; min, max: Integer);
var
  i,j: integer;
  mid: real;
begin
  if min<max then
  begin
    mid:=A[min].Rate;
    i:=min-1;
    j:=max+1;
    while i<j do
    begin
      repeat
        inc(i)
      until A[i].Rate<=mid;
      repeat
        dec(j)
      until A[j].Rate>=mid;
      if i<j then
        Swap (A[i],A[j]);
    end;
  QuickSort(A,min,j);
  QuickSort(A,j+1,max);
  end;
end;

{procedure Print (var L: TList; M: integer);
var
  i: integer;
begin
  for i:=1 to m do
    writeln (i:2,' p=',L[i].Price:5:2,' w=',L[i].Weight:5:2,' r=',L[i].Rate:5:3);
end; }

procedure MaxCost (var L: TList; M: integer; Lim: single; var Cost: single);
var
  i: integer;
  w: single;
begin
  cost:=0; i:=1; w:=0;
  while (i<=M) and (w<=Lim) do
    if l[i].Weight<=lim-w then
    begin
      w:=w+l[i].Weight;
      cost:=cost+l[i].Price;
    end
    else
      inc(i)
end;

begin
  InputList (List,M);
  write ('   : ');
  readln (Limit);
  QuickSort(List,1,M);
  MaxCost (List,M,Limit,Sum);
  writeln ('   ',Sum:0:2);
  readln;
end.
